package HTML::Mason::Commands;
use strict;
use vars qw($m $r);
my $_escape = \&HTML::Mason::Parser::_escape_perl_expression;
HTML::Mason::Component::FileBased->new
(
'code'=>sub {
my %ARGS;
if (@_ % 2 == 0) { %ARGS = @_ } else { die "Odd number of parameters passed to component expecting name/value pairs" }
my $fault = (!exists $ARGS{'fault'} ?  undef : $ARGS{'fault'});
my $_out = $m->current_sink;
$m->debug_hook($m->current_comp->path) if (%DB::);

;
# Clear out messages - they're likely irrelevant now.
clear_msg();
unless ($fault) {
    my %h = $r->headers_in;
    $fault = Bric::Util::Fault::Exception::AP->new(
      { msg => $h{BRIC_ERR_MSG} || 'No error message found',
        payload => $h{BRIC_ERR_PAY} });
}
my $msg = $fault->get_msg || '';
# Get the payload if this is a Mason-level or burn system error.
my $pay = $fault->get_payload if $msg eq 'Error processing Mason elements.'
  ||  $msg =~ /^Unable to find template/;

$m->comp('/widgets/wrappers/sharky/header.mc',
	title => 'Error',
	context => 'An error occured.',
  debug => Bric::Config::QA_MODE);
$_out->('

<p class="header">An error occurred while processing your request:</p>

<p class="errorMsg">');
$_out->( $msg );
$_out->('</p>
');
 if (ref $pay) {
$_out->('<table border="0" cellpadding="2" cellspacing="2">
    <tr>
        <td align="right"><span class="label">Class:</span></td>
        <td align="left">');
$_out->( $pay->{class} );
$_out->('</td>
    </tr>
    <tr>
        <td align="right"><span class="label">Action:</span></td>
        <td align="left">');
$_out->( $pay->{action} );
$_out->('</td>
    </tr>
    <tr>
        <td align="right"><span class="label">Output Channel:</span></td>
        <td align="left">');
$_out->( $pay->{context}{oc}->get_name );
$_out->('</td>
    </tr>
    <tr>
        <td align="right"><span class="label">Category:</span></td>
        <td align="left">');
$_out->( $pay->{context}{cat}->get_name );
$_out->('</td>
    </tr>
    <tr>
        <td align="right"><span class="label">Element:</span></td>
        <td align="left">');
$_out->( $pay->{context}{elem}->get_name );
$_out->('</td>
    </tr>
</table>
');
 } elsif ($pay) {
$_out->('<p class="errorMsg">');
$_out->( $pay );
$_out->('</p>
');
 }
$_out->('<p class="header">Please report this error to your administrator.</p>

');
$m->comp('/widgets/wrappers/sharky/footer.mc');
$_out->('














<!--

');
 $m->comp('error.html', %ARGS);
$_out->('
-->


');
return undef;

},
'create_time'=>1001668584,
'declared_args'=> {
          '$fault' => {
                        'default' => ' undef'
                      }
        },
'object_size'=>2537,
'parser_version'=>0.8
)
;