package HTML::Mason::Commands;
use strict;
use vars qw($m $r);
my $_escape = \&HTML::Mason::Parser::_escape_perl_expression;
;
my $widget = 'add_more';
# This subref will output extra fields, if necessary.
my $mk_extras = sub {
    my ($extras, $id, $obj) = @_;
    foreach (@$extras) {
	# Execute the coderef, if there is one.
	$_->{sub}->($_, $id, $obj) if $_->{sub};
	# Output the field.
	$m->out("<td>&nbsp;");
	$m->comp('/widgets/profile/displayFormElement.mc', vals => $_,
		 key => $_->{key}, useTable => 0, name => '');
	$m->out("</td>\n");
    }
};

HTML::Mason::Component::FileBased->new
(
'code'=>sub {
my %ARGS;
if (@_ % 2 == 0) { %ARGS = @_ } else { die "Odd number of parameters passed to component expecting name/value pairs" }
my $no_edit = (!exists $ARGS{'no_edit'} ?  [] : $ARGS{'no_edit'});
my $no_labels = (!exists $ARGS{'no_labels'} ?  undef : $ARGS{'no_labels'});
my $reset_key = (!exists $ARGS{'reset_key'} ?  die "no value sent for required parameter 'reset_key'" : $ARGS{'reset_key'});
my $type = (!exists $ARGS{'type'} ?  die "no value sent for required parameter 'type'" : $ARGS{'type'});
my $objs = (!exists $ARGS{'objs'} ?  [] : $ARGS{'objs'});
my $fields = (!exists $ARGS{'fields'} ?  undef : $ARGS{'fields'});
my $incr = (!exists $ARGS{'incr'} ?  1 : $ARGS{'incr'});
my $num = (!exists $ARGS{'num'} ?  4 : $ARGS{'num'});
my $label = (!exists $ARGS{'label'} ?  'Add More' : $ARGS{'label'});
my $meths = (!exists $ARGS{'meths'} ?  undef : $ARGS{'meths'});
my $use_vals = (!exists $ARGS{'use_vals'} ?  0 : $ARGS{'use_vals'});
my $extras = (!exists $ARGS{'extras'} ?  undef : $ARGS{'extras'});
my $useTable = (!exists $ARGS{'useTable'} ?  1 : $ARGS{'useTable'});
my $read_only = (!exists $ARGS{'read_only'} ?  undef : $ARGS{'read_only'});
my $param = (!exists $ARGS{'param'} ?  {} : $ARGS{'param'});
my $formName = (!exists $ARGS{'formName'} ?  "theForm" : $ARGS{'formName'});
my $deleteLabelOnly = (!exists $ARGS{'deleteLabelOnly'} ?  0 : $ARGS{'deleteLabelOnly'});
my $_out = $m->current_sink;
$m->debug_hook($m->current_comp->path) if (%DB::);

;
# Decrement, because we start from 0.
--$num;
# Grab the current URI.
my $uri = $r->uri;
substr($uri, -1, 1) = '' unless substr($uri, -1) ne '/';
# Get the current state for this widget.
my $data = get_state_data($widget);
my $add;
if ($data->{uri} && $uri eq $data->{uri}) {
    if (defined $data->{$type}{reset_key}
	&& $reset_key == $data->{$type}{reset_key}) {
	# The context is the same. Retain the current state.
	$num = $data->{$type}{num};
	$add = $data->{"add_$type"};
	set_state_data($widget, "add_$type");
    }
} else {
    # Clear out the session state.
    clear_state($widget);
}
# Increment the number of rows, if necessary.
$num += $incr if $add;
# Make the minimum equal to the number of existing rows, if that number is
# larger than $num.
$num = $#$objs if $#$objs > $num;
# Set the current state.
@{$data}{'uri', $type} = ($uri, { num => $num, reset_key => $reset_key });
set_state_data($widget, $data);

# Grab the my_meths() data.
unless ($use_vals) {
    my $pkg = get_package_name($type);
    $meths ||= $pkg->my_meths;
    # Fields should default to getting all the fields, in order.
    $fields ||= [ map { $_->{name} } $pkg->my_meths(1) ];
}
# Assemble the list of no_edit fields into a hash.
my $no_ed = { map { $_ => 1 } @$no_edit };

$_out->('<table border="0" cellpadding="2" cellspacing="0">
');
;
my $spacer = ($useTable) ? '<img src="/media/images/spacer.gif" width='. (FIELD_INDENT-8) .' height=1>'
                         : '<img src="/media/images/spacer.gif" width=50 height=1>';
# Output the headers.
unless ($no_labels) {
    $m->out("<tr>\n");
    $m->out("<td>$spacer</td>");
    if (!$deleteLabelOnly) {
	$m->out(qq{    <td><span class="label">&nbsp;$meths->{$_}->{disp}</td>\n})
	  for @$fields;
    } else {
	$m->out("<td></td>");
    }
    if (!$deleteLabelOnly) {
	$m->out(qq{    <td><span class="label">&nbsp;$_</td>\n})
	  for map { $_->{disp} } @$extras;
    } else {
	$m->out("<td></td>");
    }
    $m->out(qq{    <td><span class="label">&nbsp;Delete</td>\n})
      unless $read_only || !@$objs;
    $m->out("</tr>\n");
}
# Display all the rows.
for my $i (0..$num) {
    $m->out(qq{<tr>\n});
    $m->out("<td>$spacer</td>");
    if (my $obj = $objs->[$i]) {
        # There's an existing row. Output a hidden field with the ID.
	my $id = $use_vals ? $obj->{id} : $obj->get_id;
	$m->comp('/widgets/profile/hidden.mc', name => "${type}_id",
	         value => $id) if defined $id && !$read_only;
	# Go through all the fields.
	foreach my $f (@$fields) {
	    # Grab the value.
	    my $value = $use_vals ? $obj->{$f}
	      : $meths->{$f}{get_meth}->($obj,@{ $meths->{$f}{get_args} });
	    $m->out('    <td>');
	    # Output the field.
	    if ($no_ed->{$f}) {
		# Just output uneditable text.
		$m->out(qq{<span class="label">&nbsp;&nbsp;$value</span>});
	    } else {
		# We can output a full form element.
    		my @args = (key => $f, name => '', useTable => 0,
			    readOnly => $read_only);
		if ($use_vals) {
		    # Use vals passed explicitly.
    		    $meths->{$f}{value} = $value;
		    push @args, vals => $meths->{$f};
		} else {
		    # Use objects.
    		    push @args, objref => $obj;
		}
		$m->comp('/widgets/profile/displayFormElement.mc', @args);
	    }
	    $m->out("</td>\n");
	}
	# Output any extra fields.
	&$mk_extras($extras, $id, $obj) if $extras;
	if (defined $id && !$read_only) {
	    # Output a delete checkbox.
	    $m->out("<td>&nbsp;&nbsp;&nbsp;");
	    $m->comp('/widgets/profile/checkbox.mc', checked => 0, label_after => 1,
		     value => $id, name => "del_$type");
	    $m->out("</td>\n");
	}
    } elsif (!$read_only) {
        # There is no existing row. Output empty fields.
        foreach my $f (@$fields) {
	    $m->out('    <td>');
	    # Grab any existing value from when the 'Add More' button was
	    # clicked.
	    $meths->{$f}{value} = $param->{$f}[ $no_ed->{$f} ? $i - $#$objs - 1 : $i];
	    $m->comp('/widgets/profile/displayFormElement.mc', key => $f,
	             vals => $meths->{$f}, name => '', useTable => 0);
	    $m->out("</td>\n");
	}
	# Make any extra fields.
	&$mk_extras($extras) if $extras;
	$m->out("<td>&nbsp;</td>\n");
    }
    $m->out("</tr>\n");
}
$m->out("<tr>\n");
unless ($read_only) {
    my $span = @$fields;
    $m->out(qq{<td>$spacer</td>});
    $m->out(qq{<td colspan="$span">});

$_out->('
');
$m->comp('/widgets/profile/imageSubmit.mc',
  formName => $formName,
  callback => $widget."|".$type."|add_cb",
  image    => "add_more_lgreen");
$_out->('
');
 }
$_out->('
</table>
');
return undef;

},
'create_time'=>1001680200,
'declared_args'=> {
          '$param' => {
                        'default' => ' {}'
                      },
          '$read_only' => {
                            'default' => ' undef'
                          },
          '$extras' => {
                         'default' => ' undef'
                       },
          '$type' => {
                       'default' => undef
                     },
          '$useTable' => {
                           'default' => ' 1'
                         },
          '$fields' => {
                         'default' => ' undef'
                       },
          '$no_labels' => {
                            'default' => ' undef'
                          },
          '$label' => {
                        'default' => ' \'Add More\''
                      },
          '$no_edit' => {
                          'default' => ' []'
                        },
          '$reset_key' => {
                            'default' => undef
                          },
          '$incr' => {
                       'default' => ' 1'
                     },
          '$deleteLabelOnly' => {
                                  'default' => ' 0'
                                },
          '$objs' => {
                       'default' => ' []'
                     },
          '$use_vals' => {
                           'default' => ' 0'
                         },
          '$num' => {
                      'default' => ' 4'
                    },
          '$formName' => {
                           'default' => ' "theForm"'
                         },
          '$meths' => {
                        'default' => ' undef'
                      }
        },
'object_size'=>8267,
'parser_version'=>0.8
)
;