package HTML::Mason::Commands;
use strict;
use vars qw($m $r);
my $_escape = \&HTML::Mason::Parser::_escape_perl_expression;

my $widget = 'container_prof';

HTML::Mason::Component::FileBased->new
(
'code'=>sub {
my %ARGS;
if (@_ % 2 == 0) { %ARGS = @_ } else { die "Odd number of parameters passed to component expecting name/value pairs" }
my $tile = (!exists $ARGS{'tile'} ?  undef : $ARGS{'tile'});
my $title = (!exists $ARGS{'title'} ?  undef : $ARGS{'title'});
my $num = (!exists $ARGS{'num'} ?  undef : $ARGS{'num'});
my $action = (!exists $ARGS{'action'} ?  die "no value sent for required parameter 'action'" : $ARGS{'action'});
my $start_count = (!exists $ARGS{'start_count'} ?  undef : $ARGS{'start_count'});
my $show_summary = (!exists $ARGS{'show_summary'} ?  undef : $ARGS{'show_summary'});
my $_out = $m->current_sink;
$m->debug_hook($m->current_comp->path) if (%DB::);



# Default to using the tile passed in followed by the tile in state.
$tile ||= get_state_data($widget, 'tile');

# set the tile that we will be editing into state
set_state_data($widget, 'tile', $tile);

set_state_data($widget, 'start', $start_count);

my $state = get_state_name($widget);

# Don't change the state unless $action isn't 'edit'. 
$state = $action unless $action eq 'edit';

# Set the state name if it has not been set.
$state = set_state_name($widget, $state || 'edit');

if ($state eq 'edit_bulk') {
    $action = 'edit_bulk';

    # Load up the data the first time around.
    unless (get_state_data($widget, 'dtiles')) {
	my $field = get_state_data($widget, 'field');
	
	# Grab only the tiles that have the name $field
	my @dtiles = grep($_->get_name eq $field, $tile->get_tiles());
	
	# Load the data into an array which will be used until they finish.
	my @data = map { $_->get_data } @dtiles;
	
	# Intialize the state data.
	set_state_data($widget, 'dtiles',    \@dtiles);
	set_state_data($widget, 'data',      \@data);
	init_state_data($widget, 'separator', "\n");
	init_state_data($widget, 'cols',      80);
	init_state_data($widget, 'rows',      30);
    }
}

# Add a bit of error correction when users try to use the back buttons.
$m->out("<input type='hidden' name='$widget|top_stack_tile_id' value='".$tile->get_id."'>\n");
$m->out("<input type='hidden' name='$widget|state_name' value='".$state."'>\n");

return $m->comp("$action.html",
	 widget       => $widget,
	 num          => $num,
	 title        => $title,
	 show_summary => $show_summary,
	);


#--- Documentation ---#
$_out->('
');
$_out->('
');
#--- Arguments ---#
$_out->('
');
$_out->('
');
#--- Initialization ---#
$_out->('
');
$_out->('
');
$_out->('
');
#--- Log History ---#
$_out->('
');
return undef;

},
'create_time'=>1001676492,
'declared_args'=> {
          '$start_count' => {
                              'default' => ' undef'
                            },
          '$tile' => {
                       'default' => ' undef'
                     },
          '$title' => {
                        'default' => ' undef'
                      },
          '$num' => {
                      'default' => ' undef'
                    },
          '$action' => {
                         'default' => undef
                       },
          '$show_summary' => {
                               'default' => ' undef'
                             }
        },
'object_size'=>3264,
'parser_version'=>0.8
)
;