package HTML::Mason::Commands;
use strict;
use vars qw($m $r);
my $_escape = \&HTML::Mason::Parser::_escape_perl_expression;
;
my $widget = 'doubleListManager';

HTML::Mason::Component::FileBased->new
(
'code'=>sub {
my %ARGS;
if (@_ % 2 == 0) { %ARGS = @_ } else { die "Odd number of parameters passed to component expecting name/value pairs" }
my @leftOpts = (!exists $ARGS{'leftOpts'} ?  () : ref($ARGS{'leftOpts'}) eq 'ARRAY' ? @{$ARGS{'leftOpts'}} : ($ARGS{'leftOpts'}));
my @rightOpts = (!exists $ARGS{'rightOpts'} ?  () : ref($ARGS{'rightOpts'}) eq 'ARRAY' ? @{$ARGS{'rightOpts'}} : ($ARGS{'rightOpts'}));
my $leftCaption = (!exists $ARGS{'leftCaption'} ?  '' : $ARGS{'leftCaption'});
my $rightCaption = (!exists $ARGS{'rightCaption'} ?  '' : $ARGS{'rightCaption'});
my $leftName = (!exists $ARGS{'leftName'} ?  "all_groups" : $ARGS{'leftName'});
my $rightName = (!exists $ARGS{'rightName'} ?  "selected_groups" : $ARGS{'rightName'});
my @readOnlyLeft = (!exists $ARGS{'readOnlyLeft'} ?  () : ref($ARGS{'readOnlyLeft'}) eq 'ARRAY' ? @{$ARGS{'readOnlyLeft'}} : ($ARGS{'readOnlyLeft'}));
my @readOnlyRight = (!exists $ARGS{'readOnlyRight'} ?  () : ref($ARGS{'readOnlyRight'}) eq 'ARRAY' ? @{$ARGS{'readOnlyRight'}} : ($ARGS{'readOnlyRight'}));
my $readOnly = (!exists $ARGS{'readOnly'} ?  0 : $ARGS{'readOnly'});
my $useTable = (!exists $ARGS{'useTable'} ?  1 : $ARGS{'useTable'});
my $showLeftList = (!exists $ARGS{'showLeftList'} ?  1 : $ARGS{'showLeftList'});
my $showRightList = (!exists $ARGS{'showRightList'} ?  1 : $ARGS{'showRightList'});
my $leftJs = (!exists $ARGS{'leftJs'} ?  '' : $ARGS{'leftJs'});
my $rightJs = (!exists $ARGS{'rightJs'} ?  '' : $ARGS{'rightJs'});
my $leftSort = (!exists $ARGS{'leftSort'} ?  0 : $ARGS{'leftSort'});
my $rightSort = (!exists $ARGS{'rightSort'} ?  0 : $ARGS{'rightSort'});
my $formName = (!exists $ARGS{'formName'} ?  'theForm' : $ARGS{'formName'});
my $_out = $m->current_sink;
$m->debug_hook($m->current_comp->path) if (%DB::);

;

my ($left, $right, %seen) = ('', '');
my (@leftVals, @rightVals);


# Build the right-hand list.

foreach my $opt ($rightSort ? sort { lc $a->{description} cmp lc $b->{description} } @rightOpts : @rightOpts) {
    $seen{$opt->{value}} = 1;
    $rightVals[@rightVals] = $opt->{value};
    $right .= (!$readOnly) ? qq{   <option value="$opt->{value}">$opt->{description}</option>\n} : $opt->{description} . "<br />";
}

# Build the left-hand list.
foreach my $opt ($leftSort ? sort { lc $a->{description} cmp lc $b->{description} } @leftOpts : @leftOpts) {
    next if $seen{$opt->{value}};
    $leftVals[@leftVals] = $opt->{value};
    $left .= (!$readOnly) ?  qq{   <option value="$opt->{value}">$opt->{description}</option>\n} : $opt->{description} . "<br />";
}


$_out->('
');
$_out->('
');
$_out->('
');
$_out->('
');


unless ($rc->get("$widget.script")) {
    $m->out( qq {<script src="/javascripts/twoxlm.js"></script>\n});
    $rc->set("$widget.script", 1);
}

# if there are elements in the read only arrays, put them
# on the page in a javascript array

$m->out('<script language="javascript">'."\n");

# track the form element names for use when cleaning up submission
$m->out('doubleLists[doubleLists.length] = "' . $leftName . ":"  . $rightName . '"' . "\n\n");

# verify will need the form name too...
$m->out("formObj = false\n\n");

my $txt = '';

# write any read only values for the left side
$m->out("var $leftName"."_readOnly = new Array(" );
foreach my $opt (@readOnlyLeft) {
	$txt .= '"' . $opt . '", ';
}
$txt = substr($txt, 0, length($txt) - 2);
$m->out($txt);
$m->out(")\n\n");

$txt = ''; 

# write any read only values for the right side
$m->out("var $rightName"."_readOnly = new Array(" );
foreach my $opt (@readOnlyRight) {
	$txt .= '"' . $opt . '", ';
}
$txt = substr($txt, 0, length($txt) - 2);
$m->out($txt);
$m->out(")\n\n");

$txt = ''; 

# write all original right values
$m->out("var $rightName"."_values = new Array(" );
foreach my $val (@rightVals) {
	$txt .= '"' . $val . '", ';
}
$txt = substr($txt, 0, length($txt) - 2);
$m->out($txt);
$m->out(")\n\n");

$txt = ''; 

# write all original left values 
$m->out("var $leftName"."_values = new Array(" );
foreach my $val (@leftVals) {
	$txt .= '"' . $val . '", ';
}
$txt = substr($txt, 0, length($txt) - 2);
$m->out($txt);
$m->out(")\n\n");

$m->out("\n</script>");



$_out->('

');
 # begin html ---------------
$_out->('

<table width=578 border=0 cellpadding=0 cellspacing=0>
');

if ($showLeftList) {
    $m->out(qq{  <td width=50><img src="/media/images/spacer.gif" width=50 height=1 /></td>
                 <td width=230 align=center><span class=label>$leftCaption</span></td>}  );
} else {
    $m->out(" <td width=50>&nbsp;</td><td>&nbsp;</td>");
}

$_out->('
<td width=18 rowspan=3><img src="/media/images/spacer.gif" width=18 height=1 /></td>
');

if ($showRightList) {
    $m->out(qq { <td align=center width=230><span class=label>$rightCaption</span></td>
                 <td width=50><img src="/media/images/spacer.gif" width=50 height=1 /></td>} );
} else {
    $m->out(qq{ <td>&nbsp;</td><td width=50><img src="/media/images/spacer.gif" width=50 height=1 /></td>});
}

$_out->('
</tr>

<tr>
    <td>&nbsp;</td><td valign=top align=right>
');
 if ($showLeftList) {
   if (!$readOnly) {
$_out->('      <select name="');
$_out->( $leftName );
$_out->('" size="10" multiple style="width:225px" width="210">
      ');
$_out->( $left );
$_out->('
      </select>
');
   } else {
$_out->('      ');
$_out->( $left );
$_out->('
');
   }
 }
$_out->('    </td>
    <td valign=top>
');
 if ($showRightList) {
   if (!$readOnly) {
$_out->('      <select name="');
$_out->( $rightName );
$_out->('" size="10" multiple style="width:225px" width="210">
      ');
$_out->( $right );
$_out->('
      </select>
');
   } else {
$_out->('      ');
$_out->( $right );
$_out->('
');
   }
 }
$_out->('    </td>
    <td>&nbsp;</td>
</tr>

');


if ($showLeftList && $showRightList && !$readOnly) {
    $m->out(qq{ <tr><td>&nbsp;</td><td align="right"> });
    $m->out(qq{ <a href="#" onClick="return addToList('} .$formName . qq{', '$leftName', '$rightName'); $leftJs;">});
    $m->out(qq{<img src="/media/images/add_to_list_lgreen.gif" border=0 width=97 height=20 /></a>} );
    $m->out(qq{ </td><td align="left"> } );
    $m->out(qq{ <a href="#" onClick="return removeFromList('} .$formName . qq{', '$leftName', '$rightName'); $rightJs;">} );
    $m->out(qq{<img src="/media/images/remove_from_list_red.gif" border=0 width=134 height=20 /></a>} );
    $m->out(qq{	</td><td>&nbsp;</td></tr> });
}

$_out->('

</table>


');
return undef;

},
'create_time'=>1001668616,
'declared_args'=> {
          '$rightJs' => {
                          'default' => ' \'\''
                        },
          '$leftCaption' => {
                              'default' => ' \'\''
                            },
          '$readOnly' => {
                           'default' => ' 0'
                         },
          '@readOnlyLeft' => {
                               'default' => ' ()'
                             },
          '$leftName' => {
                           'default' => ' "all_groups"'
                         },
          '$useTable' => {
                           'default' => ' 1'
                         },
          '@rightOpts' => {
                            'default' => ' ()'
                          },
          '$rightSort' => {
                            'default' => ' 0'
                          },
          '$rightCaption' => {
                               'default' => ' \'\''
                             },
          '$showRightList' => {
                                'default' => ' 1'
                              },
          '$leftSort' => {
                           'default' => ' 0'
                         },
          '$leftJs' => {
                         'default' => ' \'\''
                       },
          '@readOnlyRight' => {
                                'default' => ' ()'
                              },
          '$showLeftList' => {
                               'default' => ' 1'
                             },
          '$formName' => {
                           'default' => ' \'theForm\''
                         },
          '@leftOpts' => {
                           'default' => ' ()'
                         },
          '$rightName' => {
                            'default' => ' "selected_groups"'
                          }
        },
'object_size'=>8410,
'parser_version'=>0.8
)
;