package HTML::Mason::Commands;
use strict;
use vars qw($m $r);
my $_escape = \&HTML::Mason::Parser::_escape_perl_expression;
;
my (%users, $fmt);
my $attr_alter = sub {
    return unless $_[0];
    my $ret = '';
    while (my ($k, $v) = each %{$_[0]}) {
        $ret .= $ret ? "<br />$k: $v" : "$k: $v";
    }
    return $ret;
};

my $trig_alter = sub {
    my $u = $users{$_[0]} ||= $_[1]->get_user;
    $u->format_name($fmt);
};

my $pl_adisp = get_class_info('alert')->get_plural_name;

HTML::Mason::Component::FileBased->new
(
'code'=>sub {
my %ARGS;
if (@_ % 2 == 0) { %ARGS = @_ } else { die "Odd number of parameters passed to component expecting name/value pairs" }
my $object = (!exists $ARGS{'object'} ?  die "no value sent for required parameter 'object'" : $ARGS{'object'});
my $obj_id = (!exists $ARGS{'obj_id'} ?  die "no value sent for required parameter 'obj_id'" : $ARGS{'obj_id'});
my $constrain = (!exists $ARGS{'constrain'} ?  undef : $ARGS{'constrain'});
my $title = (!exists $ARGS{'title'} ?  undef : $ARGS{'title'});
my $alert_uri = (!exists $ARGS{'alert_uri'} ?  undef : $ARGS{'alert_uri'});
my $_out = $m->current_sink;
$m->debug_hook($m->current_comp->path) if (%DB::);

;
my $class = get_class_info($object);
#chk_authz($class->get_pkg_name->lookup({ id => $obj_id }), READ);
@{$constrain}{qw(obj_id class_id)} = ($obj_id, $class->get_id);
$title ||= '';

my $prof_sub = sub {
    return unless $alert_uri && $_[0]->has_alerts;
    return [$pl_adisp, "$alert_uri/" . $_[0]->get_id, ''];
};
$fmt = get_pref('List Name Format');

#-- Perl Section --#
;
$m->comp('/widgets/listManager/listManager.mc',
	 object => 'event',
	 constrain => $constrain,
	 fields => [qw(name user_id timestamp attr)],
         alter => { attr => $attr_alter, user_id => $trig_alter },
	 profile => $prof_sub,
	 addition => undef,
	 title => $title,
	 select => undef);
(%users, $fmt) = ();

$_out->('


');
#-- Once Section --#
$_out->('
');
#-- Args Section --#
$_out->('
');
#-- Init Section --#
$_out->('
');
#-- Documentation --#
return undef;

},
'create_time'=>1001677798,
'declared_args'=> {
          '$alert_uri' => {
                            'default' => ' undef'
                          },
          '$title' => {
                        'default' => ' undef'
                      },
          '$constrain' => {
                            'default' => ' undef'
                          },
          '$object' => {
                         'default' => undef
                       },
          '$obj_id' => {
                         'default' => undef
                       }
        },
'object_size'=>2527,
'parser_version'=>0.8
)
;