package HTML::Mason::Commands;
use strict;
use vars qw($m $r);
my $_escape = \&HTML::Mason::Parser::_escape_perl_expression;
HTML::Mason::Component::FileBased->new
(
'code'=>sub {
my %ARGS;
if (@_ % 2 == 0) { %ARGS = @_ } else { die "Odd number of parameters passed to component expecting name/value pairs" }
my $widget = (!exists $ARGS{'widget'} ?  die "no value sent for required parameter 'widget'" : $ARGS{'widget'});
my $title = (!exists $ARGS{'title'} ?  die "no value sent for required parameter 'title'" : $ARGS{'title'});
my $fields = (!exists $ARGS{'fields'} ?  die "no value sent for required parameter 'fields'" : $ARGS{'fields'});
my $data = (!exists $ARGS{'data'} ?  die "no value sent for required parameter 'data'" : $ARGS{'data'});
my $rows = (!exists $ARGS{'rows'} ?  die "no value sent for required parameter 'rows'" : $ARGS{'rows'});
my $cols = (!exists $ARGS{'cols'} ?  die "no value sent for required parameter 'cols'" : $ARGS{'cols'});
my $userSort = (!exists $ARGS{'userSort'} ?  die "no value sent for required parameter 'userSort'" : $ARGS{'userSort'});
my $addition = (!exists $ARGS{'addition'} ?  die "no value sent for required parameter 'addition'" : $ARGS{'addition'});
my $featured = (!exists $ARGS{'featured'} ?  undef : $ARGS{'featured'});
my $featured_color = (!exists $ARGS{'featured_color'} ?  die "no value sent for required parameter 'featured_color'" : $ARGS{'featured_color'});
my $number = (!exists $ARGS{'number'} ?  0 : $ARGS{'number'});
my $empty_search = (!exists $ARGS{'empty_search'} ?  die "no value sent for required parameter 'empty_search'" : $ARGS{'empty_search'});
my $pkg = (!exists $ARGS{'pkg'} ?  undef : $ARGS{'pkg'});
my $_out = $m->current_sink;
$m->debug_hook($m->current_comp->path) if (%DB::);

;
# Load some values.
my $url       = $r->uri;
my $object    = get_state_data($widget, 'object');
my $sortBy    = get_state_data($widget, 'sortBy');
my $sort_col  = 0;

# Figure out where we are.
my ($section) = $m->comp('/lib/util/parseUri.mc');
my ($tab, $curve_left, $curve_right, $sort_class, $scolor, $ccolor);

if ($section eq 'admin') {
    ($ccolor, $scolor, $sort_class) = (qw(CC6633 CC6633 redHeader));
} else {
    ($ccolor, $scolor, $sort_class) = (qw(669999 006666 tealHeader));
}

if ($number) {
    $tab = 'lightHeader';
    $curve_left = qq{<img src="/media/images/numbers/${ccolor}_curve_$number.gif" width="20" height="19" />};
    $curve_right = qq{/media/images/CCCC99_curve_right.gif};
} else {
    $tab = $section . 'SubTab';
    $curve_left = qq{<img src="/media/images/${scolor}_curve_left.gif" width="11" height="19" />};
    $curve_right = qq{/media/images/${scolor}_curve_right.gif};
}

# Get the real values if these are code refs.  Handle profile and select
# on a row by row basis.
$addition = &$addition($pkg) if ref $addition eq 'CODE';

$_out->('<table border=0 cellpadding=0 cellspacing=0 width=580>
  <tr>
    <td class=');
$_out->( $tab );
$_out->(' valign=top width=11>');
$_out->( $curve_left );
$_out->('</td>
    <td class=');
$_out->( $tab );
$_out->(' width=558>&nbsp;');
$_out->( uc($title) );
$_out->('</td>
    <td class=');
$_out->( $tab );
$_out->(' valign=top width=11 align=right><img src="');
$_out->( $curve_right );
$_out->('" width=11 height=19></td>
  </tr>
</table>

');
 if ($addition) {
$_out->('<table border=0 cellpadding=0 cellspacing=0 width=580>
  <tr>
    <td class=lightHeader width=1><img src="/media/images/spacer.gif" width=1 height=19></td>
    <td width=10><img src="/media/images/spacer.gif" width=10 height=25></td>
    <td width=568><a class=redLinkLarge href="');
$_out->( $addition->[1] );
$_out->('">');
$_out->( $addition->[0] );
$_out->(' a New ');
$_out->( get_class_info($object)->get_disp_name );
$_out->('</a></td>
    <td class=lightHeader width=1><img src="/media/images/spacer.gif" width=1 height=19></td>
  </tr>
</table>
');
 }
$_out->('

<!-- table header display -->
<table border=1 cellpadding=2 cellspacing=0 width=580 bordercolor=#cccc99>
  <tr>
');

  my $field_disp = shift @$data;
  # Output the table header.
  foreach my $i (0..$#{$fields}) {
      my $f = $fields->[$i];
      my $disp = shift @$field_disp;

      my ($aclass, $thclass);
      if ($sortBy eq $f) {
	  ($aclass, $thclass) = ('whiteLink', $sort_class);
	  $sort_col = $i;
      } else {
	  ($aclass, $thclass) = ('blackLink', 'medHeader')
      }

      $m->out("<th class=$thclass>&nbsp;");

      # Only make a link if user sorting is enabled.
      if ($userSort) {
	  $m->out("<a class=$aclass href='$url?listManager|sortBy_cb=$f'>$disp</a>");
      } else {
	  $m->out($disp);
      }
      $m->out("</th>");
  }

  # Adjust the tabel size.
  if (scalar @$fields < $cols) {
      $m->out("<th colspan=".($cols - scalar @$fields).' class=medHeader><img src="/media/images/spacer.gif" width=1 height=19></th>');
  }

$_out->('

  </tr>

');
# Output the rows of data
 my $first;
 foreach my $r (0..$#{$data}) {
 my $o_id = shift @{$data->[$r]};
$_out->('  <tr ');
$_out->( $featured->{$o_id} ? "bgcolor=\"$featured_color\"" : "" );
$_out->('>
');

  # Output for each field.
  foreach my $c (0..$#{$data->[$r]}) {
      my $val   = $data->[$r]->[$c];
      if ($c eq $sort_col) {
	  $m->out("<td height=25 valign=top><b>$val</b></td>\n");
      } else {
	  $m->out("<td height=25 valign=top>$val</td>\n");
      }
  }

  # Fill out the rest of the columns.
  foreach ((@{$data->[$r]}+1)..$cols) {
      $m->out("<td>&nbsp;</td>\n");
  }


$_out->('

');
# End foreach my $o (@$objs)
$_out->('  </tr>
');
 }
$_out->('
');
# If there were no results (and thus none of the above is output) tell the user
 if ($rows == 1) {
 if ($empty_search) {
$_out->('  <tr><td colspan="');
$_out->( scalar @$fields );
$_out->('"></td></tr>
');
 } else {
$_out->('  <tr><td colspan="');
$_out->( scalar @$fields );
$_out->('">No ');
$_out->( lc(get_class_info($object)->get_plural_name) );
$_out->(' were found</td></tr>
');
 }
 }
$_out->('</table>

');
#--- END HTML ---#
$_out->('
');
#--- Arguments ---#
$_out->('
');
$_out->('
');
#--- Initialization ---#
$_out->('
');
$_out->('
');
#--- Log History ---#
$_out->('
');
return undef;

},
'create_time'=>1001666047,
'declared_args'=> {
          '$empty_search' => {
                               'default' => undef
                             },
          '$number' => {
                         'default' => ' 0'
                       },
          '$featured' => {
                           'default' => ' undef'
                         },
          '$fields' => {
                         'default' => undef
                       },
          '$userSort' => {
                           'default' => undef
                         },
          '$cols' => {
                       'default' => undef
                     },
          '$pkg' => {
                      'default' => ' undef'
                    },
          '$featured_color' => {
                                 'default' => undef
                               },
          '$rows' => {
                       'default' => undef
                     },
          '$widget' => {
                         'default' => undef
                       },
          '$title' => {
                        'default' => undef
                      },
          '$data' => {
                       'default' => undef
                     },
          '$addition' => {
                           'default' => undef
                         }
        },
'object_size'=>7392,
'parser_version'=>0.8
)
;