package HTML::Mason::Commands;
use strict;
use vars qw($m $r);
my $_escape = \&HTML::Mason::Parser::_escape_perl_expression;
;
my $type = 'category';
my $disp_name = get_disp_name($type);
my $pl_name = get_class_info($type)->get_plural_name;
my $root_id = Bric::Biz::Category->root_category_id;

HTML::Mason::Component::FileBased->new
(
'code'=>sub {
my %ARGS;
if (@_ % 2 == 0) { %ARGS = @_ } else { die "Odd number of parameters passed to component expecting name/value pairs" }
my $widget = (!exists $ARGS{'widget'} ?  die "no value sent for required parameter 'widget'" : $ARGS{'widget'});
my $param = (!exists $ARGS{'param'} ?  die "no value sent for required parameter 'param'" : $ARGS{'param'});
my $field = (!exists $ARGS{'field'} ?  die "no value sent for required parameter 'field'" : $ARGS{'field'});
my $obj = (!exists $ARGS{'obj'} ?  die "no value sent for required parameter 'obj'" : $ARGS{'obj'});
my $class = (!exists $ARGS{'class'} ?  die "no value sent for required parameter 'class'" : $ARGS{'class'});
my $_out = $m->current_sink;
$m->debug_hook($m->current_comp->path) if (%DB::);

;
# Grab the category object.
my $cat = $obj;
my $id = $param->{"${type}_id"};
my $name = "&quot;$param->{name}&quot;";
if ($field eq "$widget|save_cb") {
    if ($param->{delete} || $param->{delete_cascade}) {
	if ($id == $root_id) {
	    # You can't deactivate the root category!
	    add_msg("$disp_name $name cannot be deleted.");
	    return $cat;
	}
	my ($arg, $msg, $key);
	if ($param->{delete_cascade}) {
	    # We're going to delete all subcategories, too.
	    $arg = { recurse => 1 };
	    $msg = "$disp_name profile $name and all its $pl_name deleted.";
	    $key = '_deact_cascade';
	} else {
	    # We'll just be deleting this category.
	    $msg = "$disp_name profile $name deleted.";
	    $key = '_deact';
	}
        # Deactivate it.
        $cat->deactivate($arg);
	$cat->save;
	log_event($type . $key, $cat);
	add_msg($msg);
    } else {
	# Roll in the changes.
	$cat->set_name($param->{name});
	$cat->set_description($param->{description});
	$cat->set_ad_string($param->{ad_string});
	$cat->set_ad_string2($param->{ad_string2});

	# Get the parent, if necessary.
	my $par = exists $param->{parent_id} && $param->{parent_id} ne 'none'
	  ? $class->lookup({ id => $param->{parent_id} }) : undef;

	# Add new keywords.
	my $new;
	foreach (@{ mk_aref($param->{keyword}) }) {
	    next unless $_;
	    my $kw = Bric::Biz::Keyword->lookup({ name => $_ });
	    $kw ||= Bric::Biz::Keyword->new({ name => $_})->save;
	    push @$new, $kw;
	}
	$cat->add_keyword($new) if $new;

	# Delete old keywords.
	my $old;
	foreach (@{ mk_aref($param->{del_keyword}) }) {
	    next unless $_;
	    my $kw = Bric::Biz::Keyword->lookup({ id => $_ }) || next;
	    push @$old, $kw;
	}
	$cat->del_keyword($old) if $old;

	# Set the directory.
	unless (! exists $param->{directory} || (defined $id && $id == $root_id) ) {
	    # First, check to make sure that this directory isn't already used.
	    if (my @cats = $class->list({ directory => $param->{directory} })) {
		# There are categories that use the same directory. Let's check
		# their paths.
		my $uri = Bric::Util::Trans::FS->cat_uri($par->get_uri,
							$param->{directory});
		foreach my $c (@cats) {
		    if ($c->get_uri eq $uri) {
			add_msg("URI &quot;$uri&quot; is already in use. Please"
				. " try a different directory name or Parent.");
			return $cat;
		    }
		}
	    } else {
		$cat->set_directory($param->{directory});
	    }
	}

	# Save changes.
	$cat->save;

	# Establish the parent directory.
	if ( defined $param->{parent_id} && (!defined $id || $id != $root_id) ) {
	    # We have a parent ID.
	    if (my $p = $cat->parent) {
		# There's an existing parent.
		if ($p->get_id != $param->{parent_id}) {
		    # It's a new parent. Delete the old and add the new.
		    if ($param->{parent_id} eq 'none') {
			$p->del_child([$cat]);
			$p->save;
		    } else {
			$p = $class->lookup({ id => $param->{parent_id} });
			$p->add_child([$cat]);
			$p->save;
		    }
		}
	    } elsif ($param->{parent_id} ne 'none') {
		# There is no existing parent. Add the new.
		$par->add_child([$cat]);
		$par->save;
	    } else {
		# Nothin'.
	    }
	}
	log_event($type . (defined $param->{category_id} ? '_save' : '_new'),
		  $cat);
	add_msg("$disp_name profile $name saved.");
    }
    # Redirect back to the manager.
    set_redirect('/admin/manager/category');
    return $cat;
} else {
    # Nothing.
}

return undef;

},
'create_time'=>1001680214,
'declared_args'=> {
          '$param' => {
                        'default' => undef
                      },
          '$widget' => {
                         'default' => undef
                       },
          '$class' => {
                        'default' => undef
                      },
          '$obj' => {
                      'default' => undef
                    },
          '$field' => {
                        'default' => undef
                      }
        },
'object_size'=>4920,
'parser_version'=>0.8
)
;