package HTML::Mason::Commands;
use strict;
use vars qw($m $r);
my $_escape = \&HTML::Mason::Parser::_escape_perl_expression;

my @meta_props = qw(type length maxlength rows cols multiple);

HTML::Mason::Component::FileBased->new
(
'code'=>sub {
my %ARGS;
if (@_ % 2 == 0) { %ARGS = @_ } else { die "Odd number of parameters passed to component expecting name/value pairs" }
my $attr = (!exists $ARGS{'attr'} ?  die "no value sent for required parameter 'attr'" : $ARGS{'attr'});
my $usePosition = (!exists $ARGS{'usePosition'} ?  1 : $ARGS{'usePosition'});
my $form_name = (!exists $ARGS{'form_name'} ?  'theForm' : $ARGS{'form_name'});
my $useDelete = (!exists $ARGS{'useDelete'} ?  1 : $ARGS{'useDelete'});
my $readOnly = (!exists $ARGS{'readOnly'} ?  0 : $ARGS{'readOnly'});
my $_out = $m->current_sink;
$m->debug_hook($m->current_comp->path) if (%DB::);

 if ($usePosition) {
$_out->('<script>
var selectOrderNames = new Array("attr_pos")
</script>
');
 }
$_out->('
');
$_out->('
');


my $num_fields = @$attr;
my $sel_opts = [(1..$num_fields)];
my $curField = 1;
my $width = 578 - 100 * $useDelete - 100 * $usePosition;

$m->out("<table cellpadding=0 cellspacing=0 border=0 width=578>");

foreach my $attr (@$attr) {
    # Assemble the properties.
    my $props = { map { $_ => $attr->{meta}{$_}{value} } @meta_props };

    # Assemble any select/radio values.
    my $val_prop;
    if ( my $tmp = $attr->{meta}{vals}{value} ) {
	foreach my $line (split /\n/, $tmp) {
	    my ($v, $l) = split /\s*,\s*/, $line;
	    chomp $v;
	    push @$val_prop, [$v, $l];
	}
	$props->{vals} = $val_prop;
    }

    # Assemble the vals argument.
    my $vals = { value => $attr->{value},
		 props => $props,
		 disp  => $attr->{meta}{disp}{value}
	       };

    # Spit out a hidden field.
    $m->comp('/widgets/profile/hidden.mc',
	     value => $attr->{name},
	     name => 'attr_name'
	    ) if (!$readOnly);

    my $align = ($vals->{props}{type} eq 'date') ? " align=right" : '';
    $m->out("<tr><td width=$width$align>\n");

    # Spit out the attribute.
    $m->comp('/widgets/profile/displayFormElement.mc',
	     key => "attr|$attr->{name}",
	     vals => $vals,
	     useTable => ($vals->{props}{type} eq 'date') ? 0:1,
	     width => $width,
	     indent => FIELD_INDENT,
	     readOnly => $readOnly
	    );

    if ($usePosition) {
	$m->out("</td><td width=100 align=center>\n");
	$m->comp('/widgets/profile/select.mc',
		 disp     => 'Position',
		 value    => $curField++,
		 options  => $sel_opts,
		 useTable => 0,
		 name     => 'attr_pos',
		 readOnly => $readOnly,
		 js       => qq{onChange="reorder(this, '$form_name')"}
		);
	$m->out("</td>");
    }

    if ($useDelete) {
	# And spit out a delete checkbox.
	$m->out("<td width=100 align=center>\n");
	$m->comp('/widgets/profile/checkbox.mc',
		 checked => 0,
		 label_after => 1,
		 disp => 'Delete',
		 value => $attr->{name},
		 name => "del_attr",
		 useTable => 0,
		 readOnly => $readOnly
		);
	$m->out("</td>\n");
    }

    $m->out("</tr>\n");
}
$m->out("</table>");

$_out->('
');
return undef;

},
'create_time'=>1001668616,
'declared_args'=> {
          '$readOnly' => {
                           'default' => ' 0'
                         },
          '$useDelete' => {
                            'default' => ' 1'
                          },
          '$attr' => {
                       'default' => undef
                     },
          '$form_name' => {
                            'default' => ' \'theForm\''
                          },
          '$usePosition' => {
                              'default' => ' 1'
                            }
        },
'object_size'=>3559,
'parser_version'=>0.8
)
;