package HTML::Mason::Commands;
use strict;
use vars qw($m $r);
my $_escape = \&HTML::Mason::Parser::_escape_perl_expression;

my $widget = 'search';

HTML::Mason::Component::FileBased->new
(
'code'=>sub {
my %ARGS;
if (@_ % 2 == 0) { %ARGS = @_ } else { die "Odd number of parameters passed to component expecting name/value pairs" }
my $type = (!exists $ARGS{'type'} ?  die "no value sent for required parameter 'type'" : $ARGS{'type'});
my $object = (!exists $ARGS{'object'} ?  die "no value sent for required parameter 'object'" : $ARGS{'object'});
my $field = (!exists $ARGS{'field'} ?  '_default' : $ARGS{'field'});
my $groupList = (!exists $ARGS{'groupList'} ?  undef : $ARGS{'groupList'});
my $use_form_tag = (!exists $ARGS{'use_form_tag'} ?  1 : $ARGS{'use_form_tag'});
my $_out = $m->current_sink;
$m->debug_hook($m->current_comp->path) if (%DB::);



# Clear out the state information if the object changes.
my $obj_state = get_state_data($widget, 'object') || '';
if ($object ne $obj_state) {
    set_state_data($widget, {'object' => $object});
}

# Get paths and remove trailing slash
my ($prev, $cur) = (get_state_data($widget, 'crit_set_uri'), $r->uri);
$prev ? ($prev =~ s!/$!!) : ($prev = '');
$cur ? ($cur =~ s!/$!!) : ($cur = '');

# Clear state if the URI changes
unless ($prev eq $cur) {
    set_state_data($widget, {'object' => $object});
}

my $pkg = get_package_name($object);

# Get the master instance of this class.
my $meth = $pkg->my_meths();

unless (get_state_data($widget, 'field')) {
    # Find a real field name if we were given '_default'
    if ($field eq '_default') {	
	foreach my $f (keys %$meth) 	{
	    # Break out of the loop if we find the searchable field.
	    $field = $f and last if $meth->{$f}->{'search'};
	}
    }

    # Set the field on which to search.
    set_state_data($widget, 'field',  $field);
}

# Display the correct search box.
$m->comp("$type.html", widget       => $widget,
                       object       => $object,
                       disp_field   => $meth->{$field}->{'disp'},
	               groupList    => $groupList,
		       use_form_tag => $use_form_tag
	);


#--- Documentation ---#
$_out->('
');
$_out->('
');
#--- Arguments ---#
$_out->('
');
$_out->('
');
#--- Initialization ---#
$_out->('
');
$_out->('
');
$_out->('
');
#--- Log History ---#
$_out->('
');
return undef;

},
'create_time'=>1001666047,
'declared_args'=> {
          '$use_form_tag' => {
                               'default' => ' 1'
                             },
          '$groupList' => {
                            'default' => ' undef'
                          },
          '$type' => {
                       'default' => undef
                     },
          '$object' => {
                         'default' => undef
                       },
          '$field' => {
                        'default' => ' \'_default\''
                      }
        },
'object_size'=>2838,
'parser_version'=>0.8
)
;