package HTML::Mason::Commands;
use strict;
use vars qw($m $r);
my $_escape = \&HTML::Mason::Parser::_escape_perl_expression;

my $is_clear_state = sub {
    my ($param) = @_;
    my $trigger = $param->{'select_time|clear_cb'} || return;
    return $param->{$trigger};
};

HTML::Mason::Component::FileBased->new
(
'code'=>sub {
my %ARGS;
if (@_ % 2 == 0) { %ARGS = @_ } else { die "Odd number of parameters passed to component expecting name/value pairs" }
my $widget = (!exists $ARGS{'widget'} ?  die "no value sent for required parameter 'widget'" : $ARGS{'widget'});
my $field = (!exists $ARGS{'field'} ?  die "no value sent for required parameter 'field'" : $ARGS{'field'});
my $param = (!exists $ARGS{'param'} ?  die "no value sent for required parameter 'param'" : $ARGS{'param'});
my $_out = $m->current_sink;
$m->debug_hook($m->current_comp->path) if (%DB::);



if (($field eq "$widget|refresh_pc") and (not $is_clear_state->($param))) {
    # There might be many time widgets on this page.
    my $base = mk_aref($param->{$field});

    foreach  my $b (@$base) {
	# Keep this widget with this base name distict from others on the page.
	my $sub_widget = "$widget.$b";
	my @vals;
	my $incomplete = 0;
	# This is compliments $incomplete.  It tells whether *any* time fields
	# were set.  This way we know if they started to add time fields, but
	# then stopped.
	my $has_data   = 0;

	foreach my $unit (qw(year mon day hour min)) {
	    my $f = $b.'_'.$unit;
	    my $v = $param->{$f};

	    # Set the incomplete flag and stop if we get an unset date value.
	    if ($v == -1) {
		$incomplete = 1;
	    } else {
		$has_data = 1;

		# Collect the values.
		push @vals, ($v || '0');
	    }
	    

	    # Update all the time values.
	    set_state_data($sub_widget, $unit, $v) if defined $v;
	}
	
	if ($incomplete) {
	    # Clear state if this is incomplete
	    #clear_state($sub_widget);

	    # If some fields were set, flag it
	    $param->{$b.'-partial'} = 1 if $has_data;
	} else {
	    my $date = sprintf("%04d-%02d-%02d %02d:%02d:00", @vals);
	
	    # Write the date to the parameters.
	    $param->{$b} = $date;
	}
    }
}
elsif ($field eq $widget.'|clear_cb') {
    # If the trigger field was submitted with a true value then, clear state!
    if ($is_clear_state->($param)) {
	my $s = \%HTML::Mason::Commands::session;

	# Find all the select_time widget information
	my @sel = grep(substr($_,0,11) eq 'select_time', keys %$s);

	# Clear out all the state data.
	foreach my $sub_widget (@sel) {
	    set_state_data($sub_widget, {});
	}
    }
}


$_out->('
');
$_out->('
');
return undef;

},
'create_time'=>1001670213,
'declared_args'=> {
          '$param' => {
                        'default' => undef
                      },
          '$widget' => {
                         'default' => undef
                       },
          '$field' => {
                        'default' => undef
                      }
        },
'object_size'=>2859,
'parser_version'=>0.8
)
;