package HTML::Mason::Commands;
use strict;
use vars qw($m $r);
my $_escape = \&HTML::Mason::Parser::_escape_perl_expression;

my $widget = 'select_time';

my @t = localtime;
# Get a good 6 year range starting from last year.
my @year = ($t[5]+1899..$t[5]+1905);
my @mon  = qw(Jan Feb Mar Apr May Jun Jul Aug Sep Oct Nov Dec);
my @day  = ('01'..'31');
my @hour = ('00'..'23');
my @min  = ('00'..'59');

HTML::Mason::Component::FileBased->new
(
'code'=>sub {
my %ARGS;
if (@_ % 2 == 0) { %ARGS = @_ } else { die "Odd number of parameters passed to component expecting name/value pairs" }
my $base_name = (!exists $ARGS{'base_name'} ?  'time' : $ARGS{'base_name'});
my $style = (!exists $ARGS{'style'} ?  'inline' : $ARGS{'style'});
my $def_date = (!exists $ARGS{'def_date'} ?  strfdate() : $ARGS{'def_date'});
my $def_year = (!exists $ARGS{'def_year'} ?  undef : $ARGS{'def_year'});
my $def_mon = (!exists $ARGS{'def_mon'} ?  undef : $ARGS{'def_mon'});
my $def_day = (!exists $ARGS{'def_day'} ?  undef : $ARGS{'def_day'});
my $def_hour = (!exists $ARGS{'def_hour'} ?  undef : $ARGS{'def_hour'});
my $def_min = (!exists $ARGS{'def_min'} ?  undef : $ARGS{'def_min'});
my $no_year = (!exists $ARGS{'no_year'} ?  0 : $ARGS{'no_year'});
my $no_mon = (!exists $ARGS{'no_mon'} ?  0 : $ARGS{'no_mon'});
my $no_day = (!exists $ARGS{'no_day'} ?  0 : $ARGS{'no_day'});
my $no_hour = (!exists $ARGS{'no_hour'} ?  0 : $ARGS{'no_hour'});
my $no_min = (!exists $ARGS{'no_min'} ?  0 : $ARGS{'no_min'});
my $default_current = (!exists $ARGS{'default_current'} ?  0 : $ARGS{'default_current'});
my $useTable = (!exists $ARGS{'useTable'} ?  0 : $ARGS{'useTable'});
my $compact = (!exists $ARGS{'compact'} ?  0 : $ARGS{'compact'});
my $indent = (!exists $ARGS{'indent'} ?  undef : $ARGS{'indent'});
my $disp = (!exists $ARGS{'disp'} ?  undef : $ARGS{'disp'});
my $repopulate = (!exists $ARGS{'repopulate'} ?  1 : $ARGS{'repopulate'});
my $_out = $m->current_sink;
$m->debug_hook($m->current_comp->path) if (%DB::);



my %fields;
$fields{'year'} = \@year unless $no_year;
$fields{'mon'}  = \@mon  unless $no_mon;
$fields{'day'}  = \@day  unless $no_day;
$fields{'hour'} = \@hour unless $no_hour;
$fields{'min'}  = \@min  unless $no_min;

my @t;

# Get the date parts if a db date value was passed for a default.
if ($def_date) {
    # Code from Bric::Util::DBD::Pg
    eval { @t = unpack('a4 x a2 x a2 x a2 x a2 x a2', $def_date) };

    if ($@) {
	my $err_msg = "Unable to parse date '$def_date'";
	die Bric::Util::Fault::Exception::DP->new({'msg'     => $err_msg,
						 'payload' => $@});
    }
}

# Set default values if they were passed.
my ($s, $sub_widget);

$sub_widget = "$widget.$base_name";

# Only grab the old data if we are repopulating this form ourselves.
if ($repopulate) {
    $s = get_state_data($sub_widget);
}

$s->{'year'} ||= $t[0] || $def_year || '';
$s->{'mon'}  ||= $t[1] || $def_mon || '';
$s->{'day'}  ||= $t[2] || $def_day || '';
$s->{'hour'} ||= $t[3] || $def_hour || '';
$s->{'min'}  ||= $t[4] || $def_min || '';

set_state_data($sub_widget, $s);

$m->comp("$style.html", 
	 widget          => $widget, 
	 base_name       => $base_name, 
	 default_current => $default_current,
	 useTable        => $useTable,
	 indent          => $indent,
	 compact         => $compact,
	 disp            => $disp,
         %fields
	);

# Clear the state data now that the form fields have been repopulated.
set_state_data("$widget.$base_name", {});


#--- Documentation ---#
$_out->('
');
$_out->('
');
#--- Arguments ---#
$_out->('
');
$_out->('
');
$_out->('
');
#--- Initialization ---#
$_out->('
');
$_out->('
');
#--- Log History ---#
$_out->('
');
return undef;

},
'create_time'=>1001670197,
'declared_args'=> {
          '$def_date' => {
                           'default' => ' strfdate()'
                         },
          '$style' => {
                        'default' => ' \'inline\''
                      },
          '$repopulate' => {
                             'default' => ' 1'
                           },
          '$disp' => {
                       'default' => ' undef'
                     },
          '$compact' => {
                          'default' => ' 0'
                        },
          '$def_year' => {
                           'default' => ' undef'
                         },
          '$def_hour' => {
                           'default' => ' undef'
                         },
          '$default_current' => {
                                  'default' => ' 0'
                                },
          '$def_day' => {
                          'default' => ' undef'
                        },
          '$def_min' => {
                          'default' => ' undef'
                        },
          '$no_day' => {
                         'default' => ' 0'
                       },
          '$no_min' => {
                         'default' => ' 0'
                       },
          '$useTable' => {
                           'default' => ' 0'
                         },
          '$no_year' => {
                          'default' => ' 0'
                        },
          '$base_name' => {
                            'default' => ' \'time\''
                          },
          '$no_hour' => {
                          'default' => ' 0'
                        },
          '$indent' => {
                         'default' => ' undef'
                       },
          '$def_mon' => {
                          'default' => ' undef'
                        },
          '$no_mon' => {
                         'default' => ' 0'
                       }
        },
'object_size'=>5558,
'parser_version'=>0.8
)
;