package HTML::Mason::Commands;
use strict;
use vars qw($m $r);
my $_escape = \&HTML::Mason::Parser::_escape_perl_expression;

my $widget = 'summary';

my %types = ('Bric::Biz::Asset::Formatting' => 'formatting',
	     'Bric::Biz::Asset::Business::Story' => 'story',
	     'Bric::Biz::Asset::Business::Media' => 'media');

HTML::Mason::Component::FileBased->new
(
'code'=>sub {
my %ARGS;
if (@_ % 2 == 0) { %ARGS = @_ } else { die "Odd number of parameters passed to component expecting name/value pairs" }
my $asset = (!exists $ARGS{'asset'} ?  die "no value sent for required parameter 'asset'" : $ARGS{'asset'});
my $type = (!exists $ARGS{'type'} ?  'story' : $ARGS{'type'});
my $style = (!exists $ARGS{'style'} ?  'meta' : $ARGS{'style'});
my $header = (!exists $ARGS{'header'} ?  undef : $ARGS{'header'});
my $number = (!exists $ARGS{'number'} ?  undef : $ARGS{'number'});
my $frame = (!exists $ARGS{'frame'} ?  1 : $ARGS{'frame'});
my $button = (!exists $ARGS{'button'} ?  undef : $ARGS{'button'});
my $_out = $m->current_sink;
$m->debug_hook($m->current_comp->path) if (%DB::);


  my ($asset_id, $asset_obj);
  my $pkg = ref $asset;

  # Truncate any of the subpackage stuff on media
  $pkg = 'Bric::Biz::Asset::Business::Media' 
	if $pkg =~ /Bric::Biz::Asset::Business::Media/;

  if ($pkg) {
      $asset_id  = $asset->get_id;
      $asset_obj = $asset;
      $type      = $types{$pkg} || 'story';
  } else {
      $asset_id  = $asset;

      my $pkg = get_package_name($type);
      $asset_obj = $pkg->lookup({'id' => $asset_id});
  }

  my $sub_widget = $widget.'.'.$type.'.'.$asset_id;
  set_state_data($sub_widget, 'asset', $asset_obj);

  $m->comp($type.'_'.$style.'.html',
	   widget => $sub_widget,
	   header => $header,
	   number => $number,
	   frame  => $frame,
	   button => $button);

#--- Documentation ---#
$_out->('
');
$_out->('
');
#--- Arguments ---#
$_out->('
');
$_out->('
');
#--- Initialization ---#
$_out->('
');
$_out->('
');
$_out->('
');
#--- Log History ---#
$_out->('
');
return undef;

},
'create_time'=>1001676526,
'declared_args'=> {
          '$frame' => {
                        'default' => ' 1'
                      },
          '$style' => {
                        'default' => ' \'meta\''
                      },
          '$asset' => {
                        'default' => undef
                      },
          '$type' => {
                       'default' => ' \'story\''
                     },
          '$number' => {
                         'default' => ' undef'
                       },
          '$header' => {
                         'default' => ' undef'
                       },
          '$button' => {
                         'default' => ' undef'
                       }
        },
'object_size'=>2673,
'parser_version'=>0.8
)
;