package HTML::Mason::Commands;
use strict;
use vars qw($m $r);
my $_escape = \&HTML::Mason::Parser::_escape_perl_expression;
HTML::Mason::Component::FileBased->new
(
'code'=>sub {
my %ARGS;
{ local $^W; %ARGS = @_ unless (@_ % 2); }
my $_out = $m->current_sink;
$m->debug_hook($m->current_comp->path) if (%DB::);

;
# Return it if we got it.
my $ua = get_state_data('util', 'user-agent');
return wantarray ? %$ua : $ua if $ua;

# We don't got it. So get it.
#(my $agent = lc $r->header_in('User-Agent')) =~ s/_/ /;
(my $agent = lc $ENV{HTTP_USER_AGENT}) =~ s/_/ /;
my ($browser, $os, $version, $type);

# Figure out the browser and its version.
if (index($agent, 'msie') > -1) {
    # It's Internet Explorer.
    $browser = 'Internet Explorer';
	($version) = $agent =~ /msie\s*(\d+(\.\d*)?)/;
} elsif (index($agent, 'mozilla') > -1) {
    # It's Netscape or Mozilla. Find out which.
    $browser = index($agent, 'gecko') > -1 ? 'Mozilla' : 'Netscape';
    ($version) = $agent =~ /^\w+\/(.*?)\s/;
} elsif (index($agent, 'opera') > -1) {
    # It's Opera.
    $browser = 'Opera';
    ($version) = $agent =~ /opera\s*(\d+(\.\d*)?)/;
} elsif (index($agent, 'lynx') > -1) {
    # It's Lynx.
    $browser = 'Lynx';
    ($version) = $agent =~ /^\w+\/(.*?)\s/;
} else {
    # Browser is unknown. Grab what we can.
    ($browser, $version) = $agent =~ /^(.*?)\/(.*?)\s/;

    # Isolate robots...
    if    ($agent =~ /sitesnagger/)                   { $type = 'Robot'; }
    elsif ($browser =~ /googlebot/)                   { $type = 'Robot'; }
    elsif ($browser =~ /slurp/)                       { $type = 'Robot'; }
    elsif ($browser =~ /nttdirectory/)                { $type = 'Robot'; }
    elsif ($browser =~ /fast-webcrawler/)             { $type = 'Robot'; }
    elsif ($browser =~ /spider/)                      { $type = 'Robot'; }

    # Isolate "crud"... I.E. "non-browsers"...
    if    ($agent =~ /frontpage/)                     { $type = 'Crud'; }
    elsif ($agent =~ /microsoft url control/)         { $type = 'Crud'; }
    elsif ($agent =~ /gazz/)                          { $type = 'Crud'; }
    elsif ($agent =~ /proxy/)                         { $type = 'Crud'; }
    elsif ($agent =~ /^-$/)                           { $type = 'Crud'; }
}

# Play "Guess the OS"...
if    ($agent =~ /windows\s*nt/)                  { $os = "Windows NT"; }
elsif ($agent =~ /windows\s*(\d+(\.\d+)?)/)       { $os = "Windows $1"; }
elsif ($agent =~ /win95/)                         { $os = "Windows 95"; }
elsif ($agent =~ /win98/)                         { $os = "Windows 98"; }
elsif ($agent =~ /winnt/)                         { $os = "Windows NT"; }
elsif ($agent =~ /(macos|macintosh|mac|powerpc)/) { $os = "MacOS";    }
elsif ($agent =~ /(linux|freebsd|sunos)/)         { $os = "SomeNix";    }

# Create the data hash.
$ua = { browser => $browser || 'Unknown',
	version => $version || 'Unknown',
	os      => $os || 'Unknown',
	type    => $type || 'Browser'
      };

# Cache it with the session data.
set_state_data('util', 'user-agent', $ua);

# Return it.
return wantarray ? %$ua : $ua;

$_out->('
');
$_out->('
');
return undef;

},
'create_time'=>1001666047,
'object_size'=>3103,
'parser_version'=>0.8
)
;