package HTML::Mason::Commands;
use strict;
use vars qw($m $r);
my $_escape = \&HTML::Mason::Parser::_escape_perl_expression;
;
my $keys = [qw(story media formatting)];
my $pkgs = { map { $_=>  get_package_name($_) } @$keys };
my $dskpkg = 'Bric::Biz::Workflow::Parts::Desk';

HTML::Mason::Component::FileBased->new
(
'code'=>sub {
my %ARGS;
if (@_ % 2 == 0) { %ARGS = @_ } else { die "Odd number of parameters passed to component expecting name/value pairs" }
my $widget = (!exists $ARGS{'widget'} ?  die "no value sent for required parameter 'widget'" : $ARGS{'widget'});
my $param = (!exists $ARGS{'param'} ?  die "no value sent for required parameter 'param'" : $ARGS{'param'});
my $field = (!exists $ARGS{'field'} ?  die "no value sent for required parameter 'field'" : $ARGS{'field'});
my $_out = $m->current_sink;
$m->debug_hook($m->current_comp->path) if (%DB::);

;
if ($field eq "$widget|checkin_cb") {
    # Checking in assets and moving them to another desk.
    my %desks;
    foreach my $next (@{ mk_aref($param->{"desk|next_desk"})}) {
	next unless $next;
	my ($aid, $from_id, $to_id, $key) = split /-/, $next;
	my $a = $pkgs->{$key}->lookup({ id => $aid });
	my $curr = $desks{$from_id} ||= $dskpkg->lookup({ id => $from_id });
	my $next = $desks{$to_id} ||= $dskpkg->lookup({ id => $to_id });
	$curr->checkin($a);
	$curr->transfer({ to    => $next,
			  asset => $a });
	$curr->save;
	$next->save;

	# Log events.
	log_event("${key}_checkin", $a);
	log_event("${key}_moved", $a, { Desk => $next->get_name });
    }
} elsif ($field eq "$widget|delete_cb") {
    my $burn = Bric::Util::Burner->new;
    # Deleting assets.
    foreach my $key (@$keys) {
        foreach my $aid (@{ mk_aref($param->{"${key}_del_ids"}) }) {
	    my $a = $pkgs->{$key}->lookup({ id => $aid });
	    if (chk_authz($a, EDIT, 1)) {
		my $d = $a->get_current_desk;
		$d->checkin($a);
		$d->remove_asset($a);
		$d->save;
		log_event("${key}_rem_workflow", $a);
		$a->deactivate;
		$a->save;
		$burn->undeploy($a) if $key eq 'formatting';
		log_event("${key}_deact", $a);
	    } else {
		add_msg("Permission to delete &quot;" . $a->get_name
			. "&quot; denied.");
	    }
	}
    }
}

$_out->('
');
$_out->('
');
return undef;

},
'create_time'=>1001678555,
'declared_args'=> {
          '$param' => {
                        'default' => undef
                      },
          '$widget' => {
                         'default' => undef
                       },
          '$field' => {
                        'default' => undef
                      }
        },
'object_size'=>2470,
'parser_version'=>0.8
)
;