package HTML::Mason::Commands;
use strict;
use vars qw($m $r);
my $_escape = \&HTML::Mason::Parser::_escape_perl_expression;
HTML::Mason::Component::FileBased->new
(
'code'=>sub {
my %ARGS;
{ local $^W; %ARGS = @_ unless (@_ % 2); }
my $_out = $m->current_sink;
$m->debug_hook($m->current_comp->path) if (%DB::);

$_out->('
');


my $agent = $m->comp('/widgets/util/detectAgent.mc');

my ( # my, hey, hey rock and roll is here to stay

    $title,
    $header,
    $subHeader,
    $label,
    $redLabel,
    $burgandyLabel,
    $whiteLabel,
    $description,
    $errorMsg,
    $radioLabel,

    $body,
    $textInput,

    $sideNavActiveCell,
    $sideNavInactiveCell,
    $sideNavAdminCell,
    $workflowBold,
    $workflowHeader,
    $sideNavHeader,
    $sideNavHeaderBold,
    $sideNavHeaderBoldWhite,

    $blueLink,
    $blueLinkBold,
    $darkBlueLink,
    $orangeLink,
    $orangeLinkBold,
    $redLink,
    $whiteLink,
    $whiteUnderlinedLink,
    $whiteMedUnderlinedLink,
    $blackLink,
    $blackUnderlinedLink,
    $blackMedUnderlinedLink,
    $blackLinkBold,
    $redLinkLarge,

    $adminTab,
    $workflowTab,
    $whiteTextTab,
    $adminSubTab,
    $workflowSubTab,
    $darkHeader,
    $medHeader,
    $lightHeader,
    $tealHeader,
    $redHeader,
    $greyHeader,
    $tealHighlight,

    $fontFamily,
    $fontSizeSmall,
    $fontSizeMed,
    $fontSizeLarge,

);

$fontFamily    = "font-family:Verdana,Helvetica,Arial,sans-serif;";
$fontSizeSmall = "font-size:10pt;";
$fontSizeMed   = "font-size:11pt;";
$fontSizeLarge = "font-size:12pt;";

if ($agent->{browser} eq 'Mozilla') {
	$fontSizeSmall = "font-size:7.5pt;";
	$fontSizeMed   = "font-size:8pt;";
	$fontSizeLarge = "font-size:10pt;";
} elsif ($agent->{os} =~ /^Windows/) { # windows fonts one size smaller
	$fontSizeSmall = "font-size:7.5pt;";
	$fontSizeMed   = "font-size:8.5pt;";
	$fontSizeLarge = "font-size:10pt;";
} elsif ($agent->{os} eq "MacOS") { # mac fonts one size bigger
    if ($agent->{browser} eq "Netscape") {
	$fontSizeSmall = "font-size:9pt;";
	$fontSizeMed   = "font-size:10pt;";
	$fontSizeLarge = "font-size:11pt;";
    } else {
	$fontSizeSmall = "font-size:7.5pt;";
	$fontSizeMed   = "font-size:8.5pt;";
	$fontSizeLarge = "font-size:10pt;";
    }
}

# side nav classes
$sideNavActiveCell    = "{background:#999966}";
$sideNavInactiveCell  = "{background:#cccc99}";
$sideNavAdminCell     = "{background:#999966}";
$sideNavHeader        = "{$fontFamily $fontSizeSmall color:#000000; text-decoration:none}";
$sideNavHeaderBold    = "{$fontFamily $fontSizeSmall font-weight:bold; color:#000000; text-decoration:none}";
$sideNavHeaderBoldWhite="{$fontFamily $fontSizeSmall font-weight:bold; color:#ffffff; text-decoration:none}";
$workflowBold         = "{$fontFamily $fontSizeSmall font-weight:bold; color:#666633}";
$workflowHeader       = "{$fontFamily $fontSizeSmall font-weight:bold; color:#666633}";


# link classes
$orangeLink     = "{$fontFamily $fontSizeSmall color:#CC6633;}";
$orangeLinkBold = "{$fontFamily $fontSizeSmall font-weight:bold; color:#CC6633;}";
$blueLink      = "{$fontFamily $fontSizeSmall color:#669999;}";
$blueLinkBold  = "{$fontFamily $fontSizeSmall color:#669999; font-weight:bold}";
$darkBlueLink  = "{$fontFamily $fontSizeSmall color:#006666;}";
$redLink       = "{$fontFamily $fontSizeSmall color:#993300; font-weight:bold}";
$redLinkLarge  = "{$fontFamily $fontSizeMed   color:#993300; font-weight:bold}";
$whiteLink     = "{$fontFamily $fontSizeSmall color:#ffffff; text-decoration:none}";
$whiteUnderlinedLink     = "{$fontFamily $fontSizeSmall color:#ffffff;}";
$whiteMedUnderlinedLink = "{$fontFamily $fontSizeMed color:#ffffff;}";
$blackLink     = "{$fontFamily $fontSizeSmall color:#000000; text-decoration:none}";
$blackMedUnderlinedLink = "{$fontFamily $fontSizeMed color:#006666;}";
$blackLinkBold = "{$fontFamily $fontSizeSmall color:#000000; font-weight:bold}";
$blackUnderlinedLink = "{$fontFamily $fontSizeSmall color:#006666;}";

# general classes
$body         = "{$fontFamily $fontSizeSmall}";
$title        = "{$fontFamily $fontSizeLarge}";
$header       = "{$fontFamily $fontSizeLarge}";
$subHeader    = "{$fontFamily $fontSizeMed}";
$label        = "{$fontFamily $fontSizeSmall font-weight:bold}";
$redLabel     = "{$fontFamily $fontSizeSmall font-weight:bold; color:red}";
$burgandyLabel= "{$fontFamily $fontSizeSmall font-weight:bold; color:#993300}";
$whiteLabel   = "{$fontFamily $fontSizeSmall font-weight:bold; color:white}";
$description  = "{$fontFamily $fontSizeSmall color:blue}";
$errorMsg     = "{$fontFamily $fontSizeLarge color:red; font-weight:bold}";
$radioLabel   = "{$fontFamily $fontSizeLarge font-weight:bold;}";

# body classes
$adminTab        = "{background:#cc6633; $fontFamily $fontSizeLarge color:white; font-weight:bold;}";
$adminSubTab     = "{background:#cc6633; $fontFamily $fontSizeSmall color:white; font-weight:bold;}";
$workflowTab     = "{background:#006666; $fontFamily $fontSizeLarge color:white; font-weight:bold;}";
$whiteTextTab    = "{$fontFamily $fontSizeMed color:white; font-weight:bold;}";
$workflowSubTab  = "{background:#006666; $fontFamily $fontSizeSmall color:white; font-weight:bold;}";
$darkHeader      = "{background:#666633; $fontFamily $fontSizeSmall color:white; font-weight:bold;}";
$medHeader       = "{background:#999966;}";
$lightHeader     = "{background:#cccc99;}";
$greyHeader      = "{background:#cccccc;}";
$redHeader       = "{background:#993300; $fontFamily $fontSizeLarge color:white; font-weight:bold;}";
$tealHeader      = "{background:#669999; $fontFamily $fontSizeLarge color:white; font-weight:bold;}";
$textInput       = "{$fontFamily $fontSizeSmall width:200px;}";
$tealHighlight  = "{background:#669999; $fontFamily $fontSizeSmall color:white; font-weight:bold;}";

$_out->('

<style type="text/css">

BODY       ');
$_out->( $body );
$_out->('
TD         ');
$_out->( $body );
$_out->('
TH         ');
$_out->( $header );
$_out->('
.textInput ');
$_out->( $textInput );
$_out->('
.textArea  ');
$_out->( $body );
$_out->('

.blueLink       ');
$_out->( $blueLink );
$_out->('
.blueLinkBold   ');
$_out->( $blueLinkBold );
$_out->('
.orangeLink     ');
$_out->( $orangeLink );
$_out->('
.orangeLinkBold ');
$_out->( $orangeLinkBold );
$_out->('
.darkBlueLink   ');
$_out->( $darkBlueLink );
$_out->('
.redLink        ');
$_out->( $redLink );
$_out->('
.redLinkLarge   ');
$_out->( $redLinkLarge );
$_out->('
.whiteLink      ');
$_out->( $whiteLink );
$_out->('
.whiteUnderlinedLink      ');
$_out->( $whiteUnderlinedLink );
$_out->('
.blackLink      ');
$_out->( $blackLink );
$_out->('
.blackLinkBold  ');
$_out->( $blackLinkBold );
$_out->('
.whiteMedUnderlinedLink ');
$_out->( $whiteMedUnderlinedLink );
$_out->('
.blackUnderlinedLink ');
$_out->( $blackUnderlinedLink );
$_out->('
.blackMedUnderlinedLink ');
$_out->( $blackMedUnderlinedLink );
$_out->('
.sideNavActiveCell   ');
$_out->( $sideNavActiveCell );
$_out->('
.sideNavInactiveCell ');
$_out->( $sideNavInactiveCell );
$_out->('
.sideNavAdminCell    ');
$_out->( $sideNavAdminCell );
$_out->('
.sideNavHeader       ');
$_out->( $sideNavHeader );
$_out->('
.sideNavHeaderBold   ');
$_out->( $sideNavHeaderBold );
$_out->('
.sideNavHeaderBoldWhite ');
$_out->( $sideNavHeaderBoldWhite );
$_out->('


.workflowBold        ');
$_out->( $workflowBold );
$_out->('
.workflowHeader      ');
$_out->( $workflowHeader );
$_out->('

.title       ');
$_out->( $title );
$_out->('
.header      ');
$_out->( $header );
$_out->('
.subHeader   ');
$_out->( $subHeader );
$_out->('
.label       ');
$_out->( $label );
$_out->('
.redLabel    ');
$_out->( $redLabel );
$_out->('
.burgandyLabel ');
$_out->( $burgandyLabel );
$_out->('
.whiteLabel  ');
$_out->( $whiteLabel );
$_out->('
.description ');
$_out->( $description );
$_out->('
.errorMsg    ');
$_out->( $errorMsg );
$_out->('
.radioLabel  ');
$_out->( $radioLabel );
$_out->('

.adminTab       ');
$_out->( $adminTab );
$_out->('
.workflowTab    ');
$_out->( $workflowTab );
$_out->('
.adminSubTab    ');
$_out->( $adminSubTab );
$_out->('
.whiteTextTab   ');
$_out->( $whiteTextTab );
$_out->('
.workflowSubTab ');
$_out->( $workflowSubTab );
$_out->('
.darkHeader     ');
$_out->( $darkHeader );
$_out->('
.medHeader      ');
$_out->( $medHeader );
$_out->('
.lightHeader    ');
$_out->( $lightHeader );
$_out->('
.redHeader      ');
$_out->( $redHeader );
$_out->('
.tealHeader     ');
$_out->( $tealHeader );
$_out->('
.greyHeader     ');
$_out->( $greyHeader );
$_out->('
.tealHighlight  ');
$_out->( $tealHighlight );
$_out->('

</style>
');
return undef;

},
'create_time'=>1001666047,
'object_size'=>8561,
'parser_version'=>0.8
)
;