package HTML::Mason::Commands;
use strict;
use vars qw($m $r);
my $_escape = \&HTML::Mason::Parser::_escape_perl_expression;
HTML::Mason::Component::FileBased->new
(
'code'=>sub {
my %ARGS;
if (@_ % 2 == 0) { %ARGS = @_ } else { die "Odd number of parameters passed to component expecting name/value pairs" }
my $title = (!exists $ARGS{'title'} ?  "Bricolage" : $ARGS{'title'});
my $jsInit = (!exists $ARGS{'jsInit'} ?  "" : $ARGS{'jsInit'});
my $context = (!exists $ARGS{'context'} ?  die "no value sent for required parameter 'context'" : $ARGS{'context'});
my $useSideNav = (!exists $ARGS{'useSideNav'} ?  1 : $ARGS{'useSideNav'});
my $no_hist = (!exists $ARGS{'no_hist'} ?  0 : $ARGS{'no_hist'});
my $debug = (!exists $ARGS{'debug'} ?  undef : $ARGS{'debug'});
my $_out = $m->current_sink;
$m->debug_hook($m->current_comp->path) if (%DB::);

;

if ($useSideNav) {
    # first, let's bail if we need to...
    do_queued_redirect();

    # Next, log this page in the URI history
    log_history() unless $no_hist;
}

# Figure out where we are (assume workflow).
my ($section, $mode, $type) = $m->comp("/lib/util/parseUri.mc");
$section ||= 'workflow';

my ($layer, $properties);
my $agent       = $m->comp('/widgets/util/detectAgent.mc');
my $tab         = ($section eq "admin") ? "adminTab" : "workflowTab";
my $curve_left  = ($section eq "admin") ? "/media/images/CC6633_curve_left.gif" : "/media/images/006666_curve_left.gif";
my $curve_right = ($section eq "admin") ? "/media/images/CC6633_curve_right.gif" : "/media/images/006666_curve_right.gif";
my @title       = split (/ /, $title);


# calculate number of links displayed by side nav and pad out this table cell to make the page
# long enough (in the browser's mind) to render a scroll bar if needed
my $nav = get_state_data("nav");

# calculate number of links it is possible to display in the side nav
my $numLinks = $c->get("__NUM_LINKS__");
$numLinks ||= 50;

$numLinks += 8 if ($agent->{os} eq "MacOS");

# define variables to output sideNav layer or iframe
if ($agent->{browser} eq "Netscape") {
    $layer = "layer";
    $properties = qq { width=150 height="100%" border=0 scrolling="no" frameborder="no" z-index=10 left=8 top=35 };
} else {
    $layer = "iframe";
    $properties = ($agent->{os} eq "MacOS") ? qq { width=150 border=0 scrolling="no" frameborder="no" style="z-index:10;" }
                                            : " width=150 height=" . $numLinks * 24 . qq { border=0 scrolling="no" frameborder="no" style="z-index:10;" };
}

# clean up the title
$title = '';
foreach my $t (@title) {
  $title .= uc(substr($t,0,1)) .lc( substr($t,1) ) . " " ;
}

$_out->('
');
$_out->('
');
$_out->('
<html>
<head>
<title>');
$_out->( $title );
$_out->('</title>
');
 if ($useSideNav) {
$_out->('<script language="JavaScript" src="/javascripts/lib.js"></script>
');
 }
$_out->('<script language="JavaScript">

var checkboxValues = new Array();

function init() {

    ');
$_out->( $jsInit );
$_out->(';
');
 # the following is a hack for pc/ns because it fails to obey 
 # the style rule when it is first drawn.
 if ($agent->{browser} eq 'Netscape' && $jsInit =~ /showForm/) {
$_out->('    ');
$_out->( $jsInit );
$_out->(';
');
 }
$_out->('
}

</script>

<meta http-equiv="expires" content="Wed, 20 Feb 2000 08:30:00 GMT">
</head>

');
$m->comp("/widgets/wrappers/sharky/css.mc");
$_out->('

<body bgcolor="#ffffff" onLoad="init()">
<noscript>
<h1>Warning! Bricolage is designed to run with Javascript enabled.</h1>
Using Bricolage without Javascript can result in corrupt data and system instability.  Please activate Javascript in your browser before continuing.
</noscript>

<!-- begin top table -->
<table border=0 cellpadding=0 cellspacing=0 width=750>
<tr>
	<td width=150>
        <img src="/media/images/bricolage.gif" width=150 height=25>
	</td>
	<td width=600 align=right>
	 &nbsp;
	</td>
</tr>
</table>
<!-- end top tab table -->

');
 # this is the Netscape doNav function.  IE looks for it in the iframe file (ie: sideNav.mc)
$_out->('<script language="javascript">
function doNav(callback) {

');
 if ($agent->{os} eq "SomeNix") {
$_out->('
    window.location.href = callback;
    return false;

');
 } else {
$_out->('
    var rndNum = Math.round(Math.random() * 10000);
    document.layers["sideNav"].src = callback + "&uri=');
$_out->( $r->uri );
$_out->('&rnd=" + rndNum
    return false;

');
 }
$_out->('}

function doLink(link) {

    window.location.href = link
    return false
}
</script>

<!-- begin side nav and content container table -->
<table border=0 cellpadding=0 cellspacing=0 width=750 height="100%">
<tr>
  <td width=150 valign=top bgcolor="#666633" height="100%">

');


# handle the various states of the side nav
# login screen: no side nav
# Netscape (non Unix platforms): include as src of a layer
# IE: include as an iframe
# Netscape (Unix platforms): include as plain html

if ($useSideNav) {

    if ($agent->{os} eq "SomeNix") {
	$m->comp("/widgets/wrappers/sharky/sideNav.mc", debug => $debug);
    } else {
	my $uri = $r->uri;
	# create a unique uri to defeat browser caching attempts.
	$uri .= "&debug=$debug&rnd=" . time;
	chomp $uri;
	$m->out(qq { <img src="/media/images/spacer.gif" width=150 height=1> } ) if ($agent->{browser} eq "Netscape");
	$m->out( qq {<$layer name="sideNav" src="/widgets/wrappers/sharky/sideNav.mc?uri=$uri" $properties>} );
	$m->out("</$layer>\n");
    }

}


$m->out(qq { <img src="/media/images/spacer.gif" width=150 height=1> } );

$_out->('

');
 # write out space so the silly browser will provide a scroll bar for the layered content
 if ($agent->{browser} eq "Netscape" && !$agent->{browser} eq "SomeNix") { 
$_out->('
  <script language="javascript">
  for (var i=0; i < ');
$_out->( $numLinks );
$_out->('; i++) {
      document.write("<p>&nbsp;</p>");
  }
  </script>

');
 }
$_out->('
  </td>
  <td rowspan=2><img src="/media/images/spacer.gif" width=20 height=1></td>

<!-- begin content area -->

  <td width=580 valign=top rowspan=2>
');
 # top tab, help, logout buttons
$_out->('  <table width=580 cellpadding=0 cellspacing=0 border=0>
  <tr>
    <td class=');
$_out->( $tab );
$_out->(' valign=top width=11><img src="');
$_out->( $curve_left );
$_out->('" width=11 height=22></td>
    <td class=');
$_out->( $tab );
$_out->(' width=348>');
$_out->( $title );
$_out->('</td>
    <td valign=top width=11 class=');
$_out->( $tab );
$_out->('><img src="');
$_out->( $curve_right );
$_out->('" width=11 height=22></td>
');
 if ($useSideNav) {
$_out->('    <td width=140 align=right valign=top>&nbsp;<a href="/workflow/profile/alerts"><img src="/media/images/my_alerts_orange.gif" width=77 height=20 border=0 hspace=3 /></a></td>
    <td align=right width=70>
    <a href="/logout"><img src="/media/images/logout.gif" width=70 height=20 border=0></a>
    </td>
');
 } else {
$_out->('    <td width="217">&nbsp;</td>
');
 }
$_out->('  </tr>
  </table>

');
 # top message table
$_out->('  <table width=580 cellpadding=0 cellspacing=0 border=0>
  <tr>
    <td class=medHeader height=20>&nbsp;&nbsp;');
$_out->( $context );
$_out->('</td>
  </tr>

  </table>

');

# handle error messaging
my $firstMsg = 1;
while (my $txt = next_msg) {
     # insert whitespace on top to balance the line break the form tag inserts after these messages.
    if ($firstMsg) {	
	$m->out("<P>");
	$firstMsg = 0;
    }

$_out->('
<table width=580 cellpadding=0 cellspacing=0 border=0>
  <tr>
    <td height=20 valign=center>
');
    $m->out("<span class=errorMsg>$txt</span>\n");
$_out->('    </td>
  </tr>
  </table>
');
 }
$_out->('


');
$_out->('

');
return undef;

},
'create_time'=>1001666047,
'declared_args'=> {
          '$debug' => {
                        'default' => ' undef'
                      },
          '$context' => {
                          'default' => undef
                        },
          '$title' => {
                        'default' => ' "Bricolage"'
                      },
          '$no_hist' => {
                          'default' => ' 0'
                        },
          '$useSideNav' => {
                             'default' => ' 1'
                           },
          '$jsInit' => {
                         'default' => ' ""'
                       }
        },
'object_size'=>8178,
'parser_version'=>0.8
)
;